# Инструменты

Для проверки кода и упрощения работы были созданы специальные инструменты.

Для корректной работы необходим установленный make: [Ссылка на официальный сайт с гайдом](https://www.gnu.org/software/make/)


## Доступные функции

###  upload_sample
Загружает определенное кол-во строк из одной базы данных в другую.

#### Запуск
``` make sampler func=upload_sample class_name=ИМЯ_ТАБЛИЦЫ -l число ```

Здесь ИМЯ_ТАБЛИЦЫ - название класса таблицы, в которую будут копироваться данные
-l число - кол-во записей, которые надо загрузить в таблицу. Необязательный аргумент, по умолчанию - 10

#### Переменные окружения 
1. DB_LOCAL - ссылка на базу данных, из которой будут загружатся данные. 
2. DB_ONLINE - ссылка на базу данных, в которую будут загружатся данные. 


###  truncate
Очищает локальную таблицу от записей.

#### Запуск 
``` make sampler func=upload_sample class_name=ИМЯ_ТАБЛИЦЫ ```

Здесь ИМЯ_ТАБЛИЦЫ - название класса таблицы, в которую будут копироваться данные

#### Переменные окружения 
1. DB_REMOTE - ссылка на базу данных, в которую будут загружатся данные. 

## Возможные ошибки

1. ```ValueError: Function ... not found``` - неверное название функции. Названия доступных функций перечислены в документрации (см. раздел [Доступные функции](#доступные-функции))
2. ```ConnectionError: Could not connect to database. Perhaps your login/password/database for your postgres is incorrect.``` - отсутствие .env файла/неверные логин И/ИЛИ пароль в нем.
3. ```ModuleNotFoundError: No matching class found for table ...``` - неверное название класса таблицы.
4. ```ConnectionError: Table does not exist in remote database. Please check migrations in remote database``` - таблица не существует в удаленной базе данных. Скорее всего таблице нет в проде/тесте